<template>
  <v-container class="pa-0">
      <v-row v-if="isAdmin">
        <v-col cols="12">
          <v-alert dense dark color="red darken-3" icon="mdi-alert" class="mb-0">
            You are an admin on this instance with write access to all groups and projects, please exercise caution when using this feature.
          </v-alert>
        </v-col>
      </v-row>
    <v-row>
      <v-col cols="12">
        <v-card flat>
          <v-card-title class="text-h5">Apply a Compliance Framework to Projects in a Group</v-card-title>
        </v-card>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-card flat>
            <v-card-title>Select a Group<v-spacer></v-spacer><v-switch dense hide-details inset class="ma-0 pa-0" label="Search Top Level Only" v-model="topLevelOnly"></v-switch></v-card-title>
            <v-card-text>
              <GroupSelector :topLevelOnly="topLevelOnly" :selectedGroup.sync="group"></GroupSelector>
            </v-card-text>
        </v-card>
      </v-col>
    </v-row>
    <v-row v-if="groupSelected">
      <v-col cols="12">
        <v-card flat>
            <v-card-title>Projects in Scope</v-card-title>
            <v-card-text>
              <v-radio-group v-model="scope" dense hide-details class="mt-0 pt-0">
                <v-radio :value="SCOPE_ONLY_UNASSIGNED" label="Projects in this group with no framework set"></v-radio>
                <v-radio :value="SCOPE_ALL" label="All projects in this group"></v-radio>
              </v-radio-group>
              <v-checkbox dense label="Include projects in subgroups" v-model="includeSubGroups" hide-details></v-checkbox>
            </v-card-text>
        </v-card>
      </v-col>
    </v-row>
    <v-row v-if="groupSelected">
      <v-col cols="12">
        <v-card flat v-if="complianceLoading">
          <v-card-title>
            <span class="flex-grow-1" style="align-items: top">
              <v-skeleton-loader type="card-heading"></v-skeleton-loader>
            </span>
            <v-skeleton-loader class="text-align-top pr-4" type="button"></v-skeleton-loader>
          </v-card-title>
          <v-card-subtitle>
          </v-card-subtitle>
          <v-card-text>
            <v-skeleton-loader type="list-item@3"></v-skeleton-loader>
          </v-card-text>
        </v-card>
        <v-card v-else flat>
          <v-card-title>
            Select a Framework to Apply
          </v-card-title>
          <v-card-subtitle>
            Group: {{ group.full_name }}<br>
            Path: {{ group.full_path }}<br>
            Top Level Group: {{ topLevelGroup.name }}
          </v-card-subtitle>

          <v-data-table
            id="complianceTable"
            :items="complianceFrameworks[topLevelGroup.id]"
            :headers="complianceTableHeaders"
            disable-pagination
            hide-default-footer
            dense
            no-data-text="No frameworks"
            v-model="frameworkTableSelection"
            single-select
            show-select
            item-key="id"
            @click:row="frameworkRowClicked"
          >
            <template v-slot:item.name="{ item }">
              <v-icon small :color="item.color">mdi-circle</v-icon> {{ item.name }}
            </template>
          </v-data-table>
          <v-card-actions>
            <v-spacer></v-spacer>
            <v-btn v-if="projectsInScope[groupScope] == null && !loadingProjects" color="primary" depressed small :disabled="selectedFramework == null || group == null" @click="previewClicked">Preview</v-btn>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-card flat v-if="loadingProjects">
          <v-card-title class="pa-10">
            <v-spacer></v-spacer><Tanuki :loading="true" size="150"></Tanuki><v-spacer></v-spacer>
          </v-card-title>
        </v-card>
        <v-card v-if="!loadingProjects && (projectsInScope[groupScope] != null && projectsInScope[groupScope].length > 0)" flat>
          <v-card-title>
            Change Preview
            <v-spacer></v-spacer>
            <v-switch dense hide-details inset class="ma-0 pa-0" label="Hide Unchanged" v-model="hideUnchanged"></v-switch>
          </v-card-title>
          <PreviewProjectChanges :data="changePreview"></PreviewProjectChanges>
          <v-card-actions>
            <v-spacer/>
            <v-btn
              color="primary"
              depressed
              small
              :disabled="!hasChanges || isCommitting"
              @click.native="commitChanges"
            >Apply Changes</v-btn>
          </v-card-actions>
        </v-card>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-card flat v-if="isCommitting">
          <v-card-title class="pa-10">
            <v-spacer></v-spacer><Tanuki :loading="true" size="150"></Tanuki><v-spacer></v-spacer>
          </v-card-title>
        </v-card>
        <ProjectUpdateResults
        v-if="!isCommitting && commitResults.length > 0"
        :results="commitResults"
        ></ProjectUpdateResults>
      </v-col>
    </v-row>
  </v-container>
</template>

<style scoped>
  #previewTable {
    min-height: 300px;
  }
</style>

<script lang="ts">
import { Component, Watch, Mixins } from 'vue-property-decorator'
import { Getter } from 'vuex-class'
import * as Queries from '../lib/graphql_queries'
import * as Mutations from '../lib/graphql_mutations'
import ApiAccess from '../mixins/apiAccess'
import GroupTable from '../components/GroupTable.vue'
import GroupSelector from '../components/GroupSelector.vue'
import Tanuki from '../components/Tanuki.vue'
import ProjectUpdateResults from '../components/ProjectUpdateResults.vue'
import PreviewProjectChanges from '../components/PreviewProjectChanges.vue'

@Component({
  components: { GroupTable, GroupSelector, Tanuki, ProjectUpdateResults, PreviewProjectChanges }
})
export default class ApplyDefaultFrameworks extends Mixins(ApiAccess) {
  SCOPE_ONLY_UNASSIGNED = 1
  SCOPE_ALL = 2

  includeSubGroups = false
  topLevelOnly = false
  complianceLoading = false
  projectsInScope: any = {}
  frameworkTableSelection: any[] = []
  // selectedFramework: any = null
  scope = this.SCOPE_ONLY_UNASSIGNED
  @Getter isAdmin!: boolean
  group: any = null
  topLevelGroup: any = null
  complianceFrameworks: Record<string, any> = {}
  loadingProjects = false
  hideUnchanged = false
  isCommitting = false
  previewLoaded = false
  commitResults: any[] = []

  complianceTableHeaders = [
    {
      text: 'Name',
      value: 'name',
      sortable: true
    },
    {
      text: 'Description',
      value: 'description'
    },
    {
      text: 'Pipeline Path',
      value: 'pipelineConfigurationFullPath'
    }
  ]

  @Watch('group')
  async groupChanged (val: any, oldVal: any): Promise<void> {
    if (this.group && val !== oldVal) {
      this.topLevelGroup = await this.findTopLevelGroup(this.group)
    }

    this.projectsInScope = {}
    this.frameworkTableSelection = []
  }

  @Watch('topLevelGroup')
  onGroupChange (): void {
    const scope = this.topLevelGroup
    if (scope && scope.full_path) {
      this.complianceLoading = true
      this.$apollo.query({
        query: Queries.GET_GROUP_COMPLIANCE_FRAMEWORKS,
        variables: {
          fullPath: scope.full_path ?? null
        }
      }).then((result: any) => {
        this.complianceFrameworks[this.topLevelGroup.id] = result.data.group.complianceFrameworks.nodes
      }).finally(() => {
        this.complianceLoading = false
      })
    }
  }

  @Watch('includeSubGroups')
  groupScopeChanged (): void {
    if (this.previewLoaded && this.projectsInScope[this.groupScope] == null) {
      this.loadProposedChanges()
    }
  }

  get groupSelected (): boolean {
    return this.group && this.topLevelGroup
      ? Object.keys(this.group).length > 0 && Object.keys(this.topLevelGroup).length > 0
      : false
  }

  get selectedFramework (): any {
    return this.frameworkTableSelection[0] ?? null
  }

  get frameworkSelected (): boolean {
    return this.selectedFramework !== null
      ? Object.keys(this.selectedFramework).length > 0
      : false
  }

  get groupScope (): string {
    return this.includeSubGroups ? 'withSubgroups' : 'withoutSubgroups'
  }

  async previewClicked (): Promise<void> {
    await this.loadProposedChanges()
    this.previewLoaded = true
  }

  frameworkRowClicked (event: any, data: any): void {
    if (this.frameworkTableSelection.length === 1 && this.frameworkTableSelection[0] === data.item) {
      this.frameworkTableSelection = []
    } else {
      this.frameworkTableSelection = [data.item]
    }
  }

  // clearSelectedFramework (): void {
  //   this.selectedFramework = {}
  // }

  get frameworksByName (): any {
    const frameworks: any = {}
    this.complianceFrameworks[this.topLevelGroup.id].map((entry: any) => {
      frameworks[entry.name] = entry
    })

    return frameworks
  }

  get groupUri (): string {
    return this.group.web_url
  }

  get importHeader (): any {
    return ['Name', 'Path', 'Compliance Framework'].map((key) => {
      return { text: key, value: key }
    })
  }

  get hasChanges (): boolean {
    return this.changePreview.filter((entry: any) => entry.complianceChanged).length > 0
  }

  get changePreview (): any {
    return this.projectsInScope[this.groupScope]
      .filter((project: any) => {
        if (this.scope === this.SCOPE_ONLY_UNASSIGNED) {
          return !project.hasComplianceFramework
        } else {
          return true
        }
      })
      .map((project: any) => {
        project.newComplianceFramework = this.frameworkSelected ? this.selectedFramework : project.complianceFramework ?? null
        if (!project.hasComplianceFramework) {
          project.complianceChanged = project.newComplianceFramework != null
        } else {
          project.complianceChanged = project.complianceFramework.id !== this.selectedFramework.id
        }
        return project
      })
      .filter((project: any) => !this.hideUnchanged || project.complianceChanged)
  }

  async loadProposedChanges (): Promise<void> {
    // Iterate entry data imported from the sheet
    // For each entry, check whether its compliance framework changed
    if (this.groupSelected && this.frameworkSelected) {
      if (this.projectsInScope[this.groupScope] == null || this.projectsInScope[this.groupScope].length === 0) {
        this.loadingProjects = true
        await this.loadProjectsInScope()
        this.loadingProjects = false
      }
    }
  }

  async loadProjectsInScope (): Promise<void> {
    const projects = await this.getProjectsInGroup(this.group, this.includeSubGroups)
    const data = projects.map((entry: any) => {
      const project: any = {
        id: entry.id,
        name: entry.name,
        path: entry.path_with_namespace,
        description: entry.description,
        webUrl: entry.web_url,
        hasComplianceFramework: false
      }
      const complianceFrameworks = entry.compliance_frameworks
      if (complianceFrameworks) {
        const framework = this.frameworksByName[complianceFrameworks[0]]
        if (framework) {
          project.complianceFramework = framework
          project.hasComplianceFramework = true
        }
      }

      return project
    })
    this.projectsInScope[this.groupScope] = data
  }

  async commitChanges (): Promise<void> {
    this.commitResults = []
    this.isCommitting = true
    await Promise.all(this.changePreview
      .filter((entry: any) => entry.complianceChanged)
      .map(async (entry: any) => {
        const projectId = `gid://gitlab/Project/${entry.id}`
        // eslint-disable-next-line security/detect-object-injection
        const frameworkId = entry.newComplianceFramework.id

        await this.$apollo.mutate({
          mutation: Mutations.APPLY_COMPLIANCE_FRAMEWORK,
          variables: {
            projectId,
            frameworkId
          }
        }).then((result: any) => {
          const isSuccess = !result.errors || result.errors.length === 0
          this.commitResults.push({
            project: entry,
            isSuccess,
            errors: result.errors?.map((error: any) => error.message) ?? []
          })
          if (isSuccess) {
            this.updateProjectCache(entry.id, { compliance_frameworks: [entry.newComplianceFramework?.name ?? []] })
          }
        })
      }))
    this.isCommitting = false
  }
}
</script>
